<?php
/**
 * ShopEx licence
 *
 * @copyright  Copyright (c) 2005-2010 ShopEx Technologies Inc. (http://www.shopex.cn)
 * @license  http://ecos.shopex.cn/ ShopEx License
 */
 

class drm_mdl_distributor_product_sku extends dbeav_model{

    var $has_export_cnf = true;

    public $export_name = '前端货品';

    public function searchOptions(){
        $searchOptions = parent::searchOptions();
        $searchOptions['productcat_name'] = app::get('drm')->_('产品线');
        return $searchOptions;
    }

    public function _filter($filter, $tableAlias=null, $baseWhere=null){
        if(isset($filter['productcat_name']) && $filter['productcat_name'] != ''){
            $productcats = app::get('drm')->model('productcats');
            $productcats->filter_use_like = false;
            $productcat = $productcats->getList('outer_productcat_id',array('name'=>$filter['productcat_name']));
            $filter['outer_productcat_id'] = $productcat[0]['outer_productcat_id'];
            unset($filter['productcat_name']);
        }
        return parent::_filter($filter, $tableAlias, $baseWhere);
    }

    public function io_title($filter=null,$ioType='csv'){
        switch( $ioType ){
            case 'csv':
            default:
                $this->oSchema['csv']['main'] = array(
                    '*:商品名称' => 'product_id',
                    '*:货品名称' => 'name',
                    '*:商家编码' => 'outer_id',
                );
        }
        $this->ioTitle[$ioType][$filter] = array_keys( $this->oSchema[$ioType]['main'] );
        return $this->ioTitle[$ioType][$filter];
    }

    public function fgetlist_csv( &$data,$filter,$offset,$exportType = 1 ){
        @ini_set('memory_limit','64M');

        if( !$data['title'] ){
            $title = array();
            foreach( $this->io_title('main') as $k => $v ){
                $title[] = $this->charset->utf2local($v);
                //$title[] = $v;
            }
            $data['title']['main'] = '"'.implode('","',$title).'"';
        }

        $limit = 1000;

        if( !$list=$this->getList('*',$filter,$offset*$limit,$limit) )return false;

        $productObj = $this->app->model('distributor_product');
        foreach( $list as $val ){
            $product = array();
            $product = $productObj->dump($val['product_id'],'name');
            $val['product_id'] = $product['name'];
            foreach( $this->oSchema['csv']['main'] as $k => $v ){
                $row[$k] = $this->charset->utf2local($val[$v]);
                //$row[$k] = $val[$v];
                unset($v);
            }
            $data['content']['main'][] = '"'.implode('","',$row).'"';
            unset($val);
        }

        return true;
    }

    function export_csv($data,$exportType = 1 ){
        $output = array();
        foreach( $data['title'] as $k => $val ){
            $output[] = $val."\n".implode("\n",(array)$data['content'][$k]);
        }
        echo implode("\n",$output);
    }

    //根据查询条件获取导出数据
    public function getExportDataByCustom($fields, $filter, $has_detail, $curr_sheet, $start, $end){
        
        //根据选择的字段定义导出的第一行标题
        if($curr_sheet == 1){
            $data['content']['main'][] = $this->getExportTitle($fields);
        }

        if(!$list=$this->getList('*', $filter, $start, $end)){
            return false;
        }

        foreach( $list as $val ){
            $listRow['name'] = $val['name'];
            $listRow['outer_id'] = $val['outer_id'];
            $listRow['last_sync_time'] = date('Y-m-d H:i:s',$val['last_sync_time']);
            $listRow['column_scitem_id'] = $val['scitem_id'] > 0 ? "已绑定" : "未绑定";

            $exptmp_data = array();
            foreach (explode(',', $fields) as $key => $col) {
                if(isset($listRow[$col])){
                    $listRow[$col] = mb_convert_encoding($listRow[$col], 'GBK', 'UTF-8');
                    $exptmp_data[] = $listRow[$col];
                }
            }

            $data['content']['main'][] = implode(',', $exptmp_data);
        }

        return $data;
    }

    public function getExportTitle($fields){
        $export_columns = array(
            'name' => '*:产品名称',
            'outer_id' => '*:商家编码',
            'last_sync_time' => '*:最后发布时间',
            'column_scitem_id' => '*:绑定状态',
        );

        $title = array();
        foreach( explode(',', $fields) as $k => $col ){
            if(isset($export_columns[$col])){
                $title[] = $export_columns[$col];
            }
        }
        
        return mb_convert_encoding(implode(',',$title), 'GBK', 'UTF-8');
    }

    public function disabled_export_cols(&$cols){
        unset($cols['column_trade_type'], $cols['column_cost_price'], $cols['column_dealer_cost_price'], $cols['column_standard_price'], $cols['column_productcats'], $cols['quantity'], $cols['release_status']);
    }
}
?>